import { NgModule }      from '@angular/core';
import { CommonModule }  from '@angular/common';
import { RouterModule } from '@angular/router';
import { ReactiveFormsModule } from '@angular/forms';
import { HttpModule, JsonpModule } from '@angular/http';

import { AmicusComponent } from './amicus.component';
import { HeaderComponent } from './header/header.component';
import { SidebarComponent } from './sidebar/sidebar.component';
import { SidebarNotificationComponent } from './sidebar/sidebar-toggle-notification/sidebar-notification.component';
import { SidebarNotificationService } from './sidebar/shared/sidebar-notification.service';
import { FilterService } from './filter/shared/filter.service';
import { SidebarService } from './sidebar/shared/sidebar.service';
import { CoreModule } from '../core/core.module';
import { MiniDashboardService } from './header/mini-dashboard/shared/mini-dashboard.service';
import { MiniDashboardComponent } from './header/mini-dashboard/mini-dashboard.component';
import { MiniDashboardDirective } from './header/mini-dashboard/mini-dashboard.directive';
import {AmicusService} from "./shared/amicus.service";
import {AmiChartComponent} from "./ami-chart/ami-chart.component";
import {AmiFilterService} from "../modules/ami-filter/shared/ami-filter.service";
import {AuthService} from "../core/auth/auth.service";
import {AuthGuard} from "../core/auth/auth-guard.service";
import {LaravelEchoService} from "../core/laravel-echo.service";
// import {QuestionsService} from "../modules/questions/shared/questions.service";
import { AlertModule } from 'ngx-bootstrap';

@NgModule({
    imports: [
        CommonModule,
        RouterModule,
        ReactiveFormsModule,
        HttpModule,
        JsonpModule,
        CoreModule,
        AlertModule.forRoot(),
    ],

    exports: [
        AmicusComponent,
        CoreModule,
        SidebarComponent,
        HeaderComponent,
        SidebarNotificationComponent,
    ],

    declarations: [
        AmicusComponent,
        SidebarComponent,
        HeaderComponent,
        SidebarNotificationComponent,
        MiniDashboardComponent,
        MiniDashboardDirective,
    ],
    providers: [
        SidebarNotificationService,
        SidebarService,
        FilterService,
        MiniDashboardService,
        AmicusService,
        AmiFilterService,
        AuthService,
        AuthGuard,
        LaravelEchoService
    ]
})
export class AmicusModule {

}
