import { Component, OnInit } from '@angular/core';
import { AuthService } from '../../core/auth/auth.service';
import { SidebarNotificationService } from '../sidebar/shared/sidebar-notification.service';
import { MiniDashboardService } from './mini-dashboard/shared/mini-dashboard.service';
import { MiniDashboardItem } from './mini-dashboard/shared/mini-dashboard-item';
import {SidebarService} from "../sidebar/shared/sidebar.service";
import {QuestionsService} from "../../modules/questions/shared/questions.service";
import {AmicusService} from "../shared/amicus.service";
import {menuItems} from "../../../../../../src/app/menuItems";

@Component({
    selector: 'ami-header',
    templateUrl: './header.component.html',
    styleUrls: ['/header.component.scss']
})
export class HeaderComponent implements OnInit {

    protected dashboards: MiniDashboardItem[];
    private menuItems = menuItems;
    private selectedItem: string = '';
    private menu: boolean = false;

    constructor(
        // protected questionsService: QuestionsService,
        protected sidebar: SidebarService,
        protected sidebarNotification: SidebarNotificationService,
        protected auth: AuthService,
        protected miniDashboards: MiniDashboardService,
        protected amicusService: AmicusService
    ) {
    }

    ngOnInit() {
        this.dashboards = this.miniDashboards.getDashboards();
    }

    private toggleSidebar(){
      this.sidebar.toggleSidebar();
    }

    private openItem(item){
        this.selectedItem = item;
    }

    private getLink(link){
        return link ? link : 'javascript:void(0)'
    }

    private toggleMenu(){
        this.menu = !this.menu;
    }


}
