import { AfterViewInit, Component, ComponentFactoryResolver, Input, OnDestroy, ViewChild } from '@angular/core';
import { MiniDashboardItem } from './shared/mini-dashboard-item';
import { MiniDashboardDirective } from './mini-dashboard.directive';

@Component({
    selector: 'mini-dashboard',
    templateUrl: './mini-dashboard.component.html',
})
export class MiniDashboardComponent implements AfterViewInit, OnDestroy {
    @Input() public dashboards: MiniDashboardItem[];
    public currentAddIndex: number = -1;
    @ViewChild(MiniDashboardDirective) public miniDashboardHost: MiniDashboardDirective;
    public subscription: any;
    public interval: any;

    constructor(private componentFactoryResolver: ComponentFactoryResolver) { }

    ngAfterViewInit() {
        this.loadComponent();
        // this.getMiniDashboards();
    }

    ngOnDestroy() {
        clearInterval(this.interval);
    }

    loadComponent() {
        if (!this.dashboards || this.dashboards.length === 0) return false;
        this.currentAddIndex = (this.currentAddIndex + 1) % this.dashboards.length;
        let dashboardItem = this.dashboards[this.currentAddIndex];

        let componentFactory = this.componentFactoryResolver.resolveComponentFactory(dashboardItem.component);

        let viewContainerRef = this.miniDashboardHost.viewContainerRef;
        viewContainerRef.clear();

        let componentRef = viewContainerRef.createComponent(componentFactory);
        // (<MiniDashboardItemComponent>componentRef.instance).data = dashboardItem.data;
    }

    getMiniDashboards() {
        this.interval = setInterval(() => {
            this.loadComponent();
        }, 3000);
    }
}
