import { Injectable } from '@angular/core';
import { Router } from '@angular/router';
import { CanActivate } from '@angular/router';
// Import our authentication service
import { AuthService } from './auth.service';

@Injectable()
export class AuthGuard implements CanActivate {

    constructor(public auth: AuthService, public router: Router) {}

    public canActivate() {
        // If user is not logged in we'll send them to the homepage
        if (!this.auth.check()) {
            // if (this.router.url !== '/') {
            this.router.navigate(['/login']);
            // }
            return false;
        }
        return true;
    }

}
