import { Injectable } from '@angular/core';
import Echo from 'laravel-echo';
import { env } from '../../../../../src/.env';
import { AuthService } from './auth/auth.service';
import { Subject } from 'rxjs/Subject';

@Injectable()
export class LaravelEchoService {
    public echo = new Subject<any>();

    constructor(protected auth: AuthService) {
        this.auth.isAuth.subscribe((isAuth) => {
            if (isAuth) {
                this.subscribeToEcho();
            } else {
                this.echo.next(null);
            }
        });
    }

    public subscribeToEcho(){
        this.echo.next(
            new Echo({
                broadcaster: 'pusher',
                key: env('pusherKey'),
                cluster: env('pusherCluster'),
                encrypted: true,
                authEndpoint: env('pusherAuthEndpoint'),
                auth: {
                    headers: { Authorization: 'Bearer ' + this.auth.getToken() }
                }
            })
        );
    }
}
