import {LaravelEchoService} from "../laravel-echo.service";
import { AuthHttp } from 'angular2-jwt';
import {Observable} from "rxjs";
import {Subject} from "rxjs/Subject";

export class Service{

    constructor
    (
        url,
        protected echo: LaravelEchoService,
        protected http: AuthHttp,
        moduleName
    )
    {
        this.url = url;
        this.moduleName = moduleName;
    }

    private updateService = new Subject<boolean>();
    private url: string;
    private moduleName: string;
    protected stateParams = {};

    public echoInstance;

    protected connectBroadcast() {
        this.echo.echo.subscribe((echo) => {
            if (echo) {
                this.echoInstance = echo;
            }
        });
    }

    protected extractData(res: any) {
        let body = res.json();
        return body || { };
    }

    public getUrl(){
        return this.url;
    }

    public setParams(params: object = null) {
        params != null ? this.stateParams = Object.assign({}, params) : '';
        console.log(this.stateParams);
    }

    public getParamsToString(stateObj = this.stateParams, toHistory: boolean = true){
        let parameters = "?";
        for(let param in stateObj){
            if (Array.isArray(stateObj[param])){
                stateObj[param].forEach((item) => {
                    let name = param + "[]=" + item.filter + "&";
                    parameters = parameters + name;
                })
            }else{
                if (stateObj[param]){
                    let name = param + "=" + stateObj[param] + "&";
                    parameters = parameters + name;
                }
            }
        }
        if (toHistory) history.pushState("", "", `${this.moduleName}${parameters}`);
        return parameters;
    }

    public resetParams(){
        this.stateParams = {};
    }

    public findIndex(obj, collection, prop = 'id', objProp?){
        let curIndex = -1;
        let compareProp = objProp ? objProp : prop;
        for (let i = 0; i < collection.length; i++){
            collection[i][prop] == obj[compareProp] ? curIndex = i : '';
        }
        return curIndex;
    }

    public getBaseData(baseurl){
        return this.http.get(this.url + baseurl + this.getParamsToString()).map(this.extractData).catch((error:any) => Observable.throw(error.json().error || 'Ошибка соединения, попробуйте еще раз'));
    }

    public getData(url: string){
      return this.http.get(`${this.url}${url}`).map(this.extractData).catch((error: any) => Observable.throw(error.json().error || 'Ошибка соединения, попробуйте еще раз'));
    }

    public fetchService(data) {
        this.updateService.next(data);
    }

    public onFetchService() {
        return this.updateService;
    }

    public isFiltered(){
        let filter = Object.assign({}, this.stateParams);
        delete filter['page'];
        return this.getParamsToString(filter) !== '?';
    }

    public injectPage(obj: object): object{
      obj['page'] = 1;
      return obj;
    }

    public compareCollections(firstCollection, secondCollection){
        return JSON.stringify(firstCollection) === JSON.stringify(secondCollection);
    }

}
