import {
    Component, ElementRef, Input, NgZone, OnChanges, OnInit, ViewChild
} from '@angular/core';

import Chart from 'chart.js';

@Component({
  selector: 'ami-chart',
  templateUrl: './ami-chart.component.html',
})

export class AmiChartComponent implements OnInit,OnChanges {
    @ViewChild('statChart') statChart: ElementRef;
    @Input() type;
    @Input() datasets;
    @Input() title;
    @Input() width;
    @Input() height;
    private chart;

  ngOnInit(){
      let ctx = this.statChart.nativeElement.getContext('2d');
      this.chart = new Chart(ctx, {
          type: this.type,
          data: this.datasets,
          options: {
              title: {
                  display: true,
                  text: this.title,
                  fontStyle: 'bold',
                  fontSize: 28
              }
          }
      });
  }

  ngOnChanges() {
    if (this.chart){
        this.chart.data = this.datasets;
        this.chart.options.title.text = this.title;
        this.chart.update();
    }
  }

  constructor() {
  }

}
