import { Injectable } from '@angular/core';

import {Http, RequestOptions, Response} from '@angular/http';

import 'rxjs/add/operator/catch';
import 'rxjs/add/operator/map';
import { AuthHttp } from 'angular2-jwt';
import "rxjs/add/operator/timeout";
import "rxjs/add/operator/delay";
import * as moment from 'moment';
import {env} from "../../../.env";

@Injectable()
export class ChartDataService {

    // here we have methods to handle data and send to chart component

    constructor(){

    }

    public periods = [
        {
            period: 'hourly',
            momentPeriod: 'hour' ,
            format: 'YYYY-MM-DD HH'
        },
        {
            period: 'daily',
            momentPeriod: 'day' ,
            format: 'YYYY-MM-DD'
        },
        {
            period: 'weekly',
            momentPeriod: 'week' ,
            format: 'YYYY-MM-DD'
        },
        {
            period: 'monthly',
            momentPeriod: 'month' ,
            format: 'YYYY-MM'
        },
    ];

    private CompareDateArrays(DateArr, date, filter, period){
        let result = 0;

        period == 'week' ? date = moment(date).format('YYYY WW') : '';

        DateArr.forEach((curDate) => {
            curDate.date === date ? result = curDate[filter] : '';
        });

        return result;
    }

    public fillStatArr(comingArr ,period, format, date, exposed_filter){
        let dateSplit = date;
        let filter = exposed_filter;
        let dStart, dEnd, dStep;
        let resultArray = [];

        dStart = dateSplit.length === 0 ? moment().startOf('month') : moment(dateSplit[0]);
        dEnd = dateSplit.length === 0 ? moment() : moment(dateSplit[1]);
        dStep = moment(dStart.format(format));

        while (dStep.isSameOrBefore(dEnd)) {
            let tempData = {
                "date"  : dStep.format(format),
            };
            tempData[filter] = this.CompareDateArrays(comingArr, dStep.format(format), filter, period);
            resultArray.push(tempData);
            dStep = dStep.add(1, period);
        }

        return resultArray;
    }

}
