import {
    Component, Input, OnInit, ViewContainerRef, ViewChild, ReflectiveInjector, ComponentFactoryResolver,
    Output, EventEmitter
} from '@angular/core';
import {AmiFilterService} from "../shared/ami-filter.service";


@Component({
    selector: 'ami-filter-dropdown',
    templateUrl: './ami-filter-dropdown.component.html',
    styleUrls: ['./ami-filter-dropdown.component.css']
})
export class AmiFilterDropdownComponent{

    @Input() prop: Array<any>;
    @Input() button: boolean;
    @Input() data;
    @Input() title;
    @Output() protected setted: EventEmitter<any> = new EventEmitter();

    constructor(private amiFilterService: AmiFilterService) { }

    private changeProp(item){
        let index = this.amiFilterService.findIndex(item, this.prop, 'filter');
        index === -1 ? this.prop.push(item) : this.prop.splice(index, 1);
        this.setted.emit(this.prop);
    }

}

