   import {
    Component, Input, OnInit, ViewContainerRef, ViewChild, ReflectiveInjector, ComponentFactoryResolver,
    Output, EventEmitter
} from '@angular/core';
   import {AmiFilterService} from "../shared/ami-filter.service";
   import {Subject} from "rxjs/Subject";
   import {Observable} from "rxjs/Observable";


@Component({
    selector: 'ami-filter-typeahead',
    templateUrl: './ami-filter-typeahead.component.html',
    styleUrls: ['./ami-filter-typeahead.component.css']
})
export class AmiFilterTypeaheadComponent implements OnInit{
  @Input() private title: string = "Не указано";
  @Input() private desc: string;
  @Input() private url: string;
  @Output() protected setted: EventEmitter<any> = new EventEmitter();

  private search = new Subject<string>();
  private items: Array<any> = [];
  private itemSelected: Array<any> = [];
  private show: boolean = false;

  private Search(value:any = ""){
      this.search.next(value);
  }

  private Select($event){
      this.itemSelected.push({filter: $event.id});
      this.setted.emit(this.itemSelected);
  }

  private Remove($event){
      let index = this.itemSelected.indexOf($event.id);
      this.itemSelected.splice(index, 1);
      this.setted.emit(this.itemSelected);
  }

  constructor(private amiFilterService: AmiFilterService) {

  }

  ngOnInit(){

      this.search
          .debounceTime(1000)
          .switchMap(term => term
              ? this.amiFilterService.getTypeaheadSearch(term, this.url)
              : Observable.of<any[]>([]))
          .catch(error => {
              return Observable.of<any>([]);
          }).subscribe((data) => {
          let newContenders = [];
          if (data.data.length > 0){
              data.data.forEach((item) => {
                  newContenders.push({id: item.id, text: item.firstname + ' ' + item.lastname});
              });
          }else{
              newContenders.push({id: 2, text: "Такого клиента не найдено"});
          }
          this.items = newContenders;
      });
      this.Search(" ");
  }

}

