import { NgModule }      from '@angular/core';
import { CommonModule } from '@angular/common';

import { CoreModule } from '../core/core.module';
import {AmiFilterService} from "./shared/ami-filter.service";
import {AmiFilterSimpleComponent} from "./ami-filter-simple/ami-filter-simple.component";
import {AmiFilterSearchComponent} from "./ami-filter-search/ami-filter-search.component";
import {FormsModule} from "@angular/forms";
import {AmiFilterDropdownComponent} from "./ami-filter-dropdown/ami-filter-dropdown.component";
import {AmiFilterDateComponent} from "./ami-filter-date/ami-filter-date.component";
import {Daterangepicker} from "ng2-daterangepicker";
import {AmiFilterTypeaheadComponent} from "./ami-filter-typeahead/ami-filter-typeahead.component";
import {SelectModule} from "ng2-select";

@NgModule({
    imports: [
        CommonModule,
        FormsModule,
        Daterangepicker,
        SelectModule
    ],
    declarations: [
        AmiFilterSimpleComponent,
        AmiFilterSearchComponent,
        AmiFilterDropdownComponent,
        AmiFilterDateComponent,
        AmiFilterTypeaheadComponent
    ],
    exports: [
        AmiFilterSimpleComponent,
        AmiFilterSearchComponent,
        AmiFilterDropdownComponent,
        AmiFilterDateComponent,
        AmiFilterTypeaheadComponent
    ],
    providers: [AmiFilterService]
})
export class AmiFilterModule {}
