import { Injectable } from '@angular/core';

import {Http, RequestOptions, Response} from '@angular/http';

import 'rxjs/add/operator/catch';
import 'rxjs/add/operator/map';
import { AuthHttp } from 'angular2-jwt';
import "rxjs/add/operator/timeout";
import "rxjs/add/operator/delay";
import * as moment from 'moment';
import {env} from "../../../../../../../src/.env";
import {Service} from "../../../core/shared/service";
import {LaravelEchoService} from "../../../core/laravel-echo.service";

@Injectable()
export class AmiFilterService extends Service{

    constructor(protected http: AuthHttp, protected echo: LaravelEchoService){
        super(env('apiUrl'), echo, http, '');
    }

    public setFilterProp(prop: string, value: any, filter){
        filter[prop] ?  delete filter[prop] : filter[prop] = value;
    }

    public setFilterPropArr(id: any, array: any, filter){
        let index = filter[array].indexOf(id);

        index == -1 ? filter[array].push(id) : filter[array].splice(index,1);
    }

    public getTypeaheadSearch(name: string = "", url: string){
        let requestUrl = env('apiUrl') + url;
        if (name != ""){
            requestUrl = requestUrl + "?search=" + name;
        }
        return this.http.get(requestUrl).map(this.extractData);
    }

    protected extractData(res: Response) {
        let body = res.json();
        return body || { };
    }
}
