import {
  Component, EventEmitter,
  Input,
  Output
} from '@angular/core';


@Component({
    selector: 'pagination',
    templateUrl: './pagination.component.html',
})
export class PaginationComponent{

  @Input() page;
  @Input() last_page;
  @Input() total;
  @Input() per_page;

  private pageId;

  @Output() protected pageChange: EventEmitter<any> = new EventEmitter();

  constructor(){}

  getPage(page){
    if (page != 0 && page <= this.last_page){
      this.pageChange.emit({page: page});
    }
  }

  findPage(page: any){
    page = parseInt(page);
    if (!isNaN(page)){
      this.getPage(page);
    }
    this.pageId = "";
  }

}
