/**
 * Angular bootstrapping
 */
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { decorateModuleRef } from './app/environment';

let Pusher = require('pusher-js');

export let collect = require('collect.js');

// window.jQuery = window.$ = jquery;
import 'jquery';
let bootstrap = require('bootstrap');
// import Chart from 'chart.js';
// require('../node_modules/bootstrap-datepicker/dist/locales/bootstrap-datepicker.ru.min');
/**
 * App Module
 * our top level module that holds all of our components
 */
import { AppModule } from './app';
import * as moment from 'moment';

/**
 * Bootstrap our Angular app with a top level NgModule
 */
export function main(): Promise<any> {
    return platformBrowserDynamic()
        .bootstrapModule(AppModule)
        .then(decorateModuleRef)
        .catch((err) => console.error(err));
}

/**
 * Needed for hmr
 * in prod this is replace for document ready
 */
switch (document.readyState) {
    case 'loading':
        document.addEventListener('DOMContentLoaded', _domReadyHandler, false);
        break;
    case 'interactive':
    case 'complete':
    default:
        main();
}

function _domReadyHandler() {
    document.removeEventListener('DOMContentLoaded', _domReadyHandler, false);
    main();
}